% This MATLAB program plots contours for cointegration example

% ===============================================
% first generate data
% specify true values
truea = [1;-1];
trueb = [0;1];

% following lines make sure same random numbers are generated each time
% program is run
dseed = 69323;
randn('state',dseed);

capt = 50;
eps = randn(2,capt);
y = zeros(2,1);
ylag = y;
it = 1;
while it <= capt;
    ylag = ylag + trueb*(truea'*ylag) + eps(:,it);
    y = [y ylag];
it = it+1;
end;
dely = y(:,2:capt+1) - y(:,1:capt);  % This is the change in y 
ylag = y(:,1:capt);

zvals = [-132 -142 -160];
zvals = [zvals -200:-100:-40000];

subplot('Position',[0.2 0.7 0.6 0.15])
[alpha1,alpha2,likes] = twobytwo(dely,ylag,truea,trueb,1);
contour(alpha1,alpha2,likes,zvals)
xlabel('a2')
ylabel('b2')
title('a1 = 1')
likes1 = likes;
[C IX] = max(likes);
[Q IY] = max(C');
disp('case 1')
disp('max value for log likelihood is')
Q
IX = IX(IY);
disp('max occurs at b2 =')
alpha1(IX)
disp('a2=')
alpha2(IY)

subplot('Position',[0.2 0.4 0.6 0.15])
[alpha1,alpha2,likes] = twobytwo(dely,ylag,truea,trueb,2);
contour(alpha1,alpha2,likes,zvals)
xlabel('a1')
ylabel('b2')
title('a2=1')
likes2 = likes;
[C IX] = max(likes);
[Q IY] = max(C');
disp('case 2')
disp('max value for log likelihood is')
Q
IX = IX(IY);
disp('max occurs at b2 =')
alpha1(IX)
disp('a1=')
alpha2(IY)

subplot('Position',[0.2 0.1 0.6 0.15])
[alpha1,alpha2,likes] = twobytwo(dely,ylag,truea,trueb,3);
contour(alpha1,alpha2,likes,zvals)
xlabel('a1')
ylabel('a2')
title('b2=1')
[C IX] = max(likes);
[Q IY] = max(C');
disp('case 3')
disp('max value for log likelihood is')
Q
IX = IX(IY);
disp('max occurs at a2 =')
alpha1(IX)
disp('a1=')
alpha2(IY)


