function likec = likely(y,mu1,mu2,p);
% This MATLAB function file evaluates log likelihood for mixture example
% 	  inputs:
%		y = (n x 1) vector of observations
%		mu1 = value of first mean
%		mu2 = value of second mean
%		p = probability
%	   output:
%		log likelihood 
	[n,g] = size(y);
	likeq = p*exp(-((y - mu1).^2)/2) + (1-p)*exp(-((y - mu2).^2)/2);
	likeq = sum(log(likeq));
	likeq = likeq - (n/2)*log(2*pi);
likec = likeq;
