function [mu1,mu2,likes,thet]=twobytwo(ydata,p);
% This Matlab function calculates matrix of data used to generate a contour plot
% for mixture distributions
% inputs:
% 	p = value of probability of state 1
%	ydata = (n x 1) vector of observations
% outputs:
% thet = 3 x 2 matrix
%    (1,1) element = value of mu1 for first local max
%    (2,1) element = value of mu2 for first local max
%    (3,1) element = value of log likelihod for first local max
%    second column = ditto for second local max

delj = 0.05;
nj = 6/0.05 + 1;
mu1 = -3:delj:3;
mu2 = -3:delj:3;
likes = zeros(nj,nj);
thet=zeros(3,2);

icount = 1;
i = 1;
while i <= nj;
	j = 1;
	while j <= nj;
  		likes(i,j) = likely(ydata,mu1(i),mu2(j),p);
        j = j+1;
    end;
i = i+1;
end;
i = 2;
while i < nj;
    j = 2;
    while j < nj;
        if (likes(i,j)>likes(i,j-1))&(likes(i,j)>likes(i,j+1))...
            &(likes(i,j)>likes(i-1,j))&(likes(i,j)>likes(i+1,j));
            if icount == 1;
                thet(1,1) = mu1(i);
                thet(2,1) = mu2(j);
                thet(3,1) = likes(i,j);
                icount = 2;
            else;
                thet(1,2) = mu1(i);
                thet(2,2) = mu2(j);
                thet(3,2) = likes(i,j);
            end;
        end;
    j = j+1;        
    end;
i = i+1;
end;



