% This MATLAB program plots contours for supply example with pi-normalization
% first load in data
load ydata.txt -ascii
[rows,cols] = size(ydata)

% convert to resids to concentrate likelihood function
y0 = ydata(4:rows,:);
y1 = ydata(3:rows-1,:);
y2 = ydata(2:rows-2,:);
xmat = [y1 y2];
bhat = inv(xmat'*xmat)*xmat'*y0;
uhat = y0 - xmat*bhat;
x2mat = [y1(:,3) y2(:,3)];      % x2mat just has the weather
b2hat = inv(x2mat'*x2mat)*x2mat'*y0(:,3);
uhat(:,3) = y0(:,3) - x2mat*b2hat;  % so likelihood is concentrated with
                                    % restrictions on B1 and B2
ydata = uhat;

pi1 = 0.4;
pi2 = -0.2;
rho = -0.51;
Pi_likely(ydata,pi1,pi2,rho)

subplot('Position',[0.1 0.72 0.32 0.19])
[alpha1,alpha2,likes,thet] = Pi_twobytwo(0.9,ydata);
Pi_contourmax;
title('\rho=0.9')

subplot('Position',[0.52 0.72 0.32 0.19])
[alpha1,alpha2,likes,thet] = Pi_twobytwo(0.5,ydata);
Pi_contourmax;
title('\rho=0.5')

subplot('Position',[0.1 0.40 0.32 0.19])
[alpha1,alpha2,likes,thet] = Pi_twobytwo(0.10,ydata);
Pi_contourmax;
title('\rho=0.1')

subplot('Position',[0.52 0.40 0.32 0.19])
[alpha1,alpha2,likes,thet] = Pi_twobytwo(0,ydata);
Pi_contourmax;
title('\rho=0')

subplot('Position',[0.1 0.08 0.32 0.19])
[alpha1,alpha2,likes,thet] = Pi_twobytwo(-0.5,ydata);
Pi_contourmax;
title('\rho=-0.5')

subplot('Position',[0.52 0.08 0.32 0.19])
[alpha1,alpha2,likes,thet] = Pi_twobytwo(-0.9,ydata);
Pi_contourmax;
title('\rho=-0.9')
