
#ifndef __FILESETUP__
#define __FILESETUP__

#include "matrix.h"
#include "var.h"

typedef struct
{
 /* True parameters and initial values */
 TMatrix *A;
 TMatrix  A_true;
 TMatrix  F_true;
 TVector  C;
 TMatrix  InitialValues;

 /* Restrictions */
 TMatrix *Q, EC, EP;

 /* Number of variables  */
 int n_var;
 int n_lag;
 int n_exg;
 int n_pre;

 /* Sample sizes */
 int n_obs;
 int inner_loop;
 int outer_loop;
 int parameter_draws;

 int seed;
 int burn_in;

 /* Parameterizaton */
 int parameterization;

 /* Data */
 

 /* MLE */
 TMatrix A_hat;
 TMatrix F_hat;

} file_setup_type;

int ParseCommandLine(int n_arg, char **args, char ch);
char* ParseCommandLine_String(int n_arg, char **args, char ch, char *default_return);
int ParseCommandLine_Integer(int n_arg, char **args, char ch, int default_return);
int SetFilePosition(FILE *f, char *id);

void FreeFileSetup(file_setup_type *setup);
file_setup_type* SetupFromFile(FILE *f_in);

void PrintFileSetup(FILE *f, file_setup_type *setup);
TMatrix GenerateData(file_setup_type *setup);
T_SVAR* SetupFromStructure(file_setup_type *setup, TMatrix Data);

TMatrix* MakeLinearRestrictions(TMatrix EC, TMatrix EP, int n, int k);

#endif
