
#ifndef __BMATRIX__
#define __BMATRIX__

#include "prcsn.h"
#include "m_err.h"

#ifdef __cplusplus
extern "C"
{
#endif

/* Unary Operators */
int bNegative(PRECISION *x, PRECISION *y, int n);
int bAbs(PRECISION *x, PRECISION *y, int n);
int bTranspose(PRECISION *x, PRECISION *y, int m, int n);
int bTransposeInPlace(PRECISION *x, int m);

/* Addition */
int bAdd(PRECISION *x, PRECISION *y, PRECISION *z, int n);
int bSubtract(PRECISION *x, PRECISION *y, PRECISION *z, int n);

/* Multiplication */
int bMultiply(PRECISION *x, PRECISION *y, PRECISION s, int n);
int bMatrixMultiply(PRECISION *x, PRECISION *y, PRECISION *z, int m, int n, int p, int xt, int yt, int zt);

/* LU Decomposition */
int bLU(int *p, PRECISION *x, int m, int n);
int bSolveTriangular(PRECISION *x, PRECISION *b, int m, int n, int u, int xt, int bt);
int bSolveUnitTriangular(PRECISION *x, PRECISION *b, int m, int n, int u, int xt, int bt);

/* QR Decompositions */
int bQR(PRECISION *Q, PRECISION *R, int m, int n);

/* Singular Value Decomposition */
int bSVD(PRECISION *U, PRECISION *d, PRECISION *V, int m, int n);

/* Cholesky Decompositions */
int bCholesky(PRECISION *X, int m, int u, int t);

/* Permutation Routines */
int bPermutationMultiply(int *p, PRECISION *y, int m, int n, int q, int pt, int yt);
int bPermutation(PRECISION *x, int *p, int m, int q, int t);

//int bQRPivot_R(PRECISION *R, int *p, int m, int n);
//int bQRPivot_QR(PRECISION *Q, PRECISION *R, int *p, int m, int n);

#ifdef __cplusplus
}
#endif

#endif 


