
#ifndef __WALD_NORMALIZATION__
#define __WALD_NORMALIZATION__

#include "matrix.h"
#include "var.h"

typedef struct
{
 TMatrix S;
 TMatrix A;
 TMatrix F;
} TWaldNormalization;

TMatrix CommutationMatrix(TMatrix X, int m, int n);

TMatrix InformationMatrix_1stDerivative(TMatrix A, TMatrix F, TMatrix Data, TMatrix Exg, int p);
TMatrix InformationMatrix_2ndDerivative(TMatrix A, TMatrix F, TMatrix Data, TMatrix Exg, int p);

void NormalizeWald(TMatrix A, TMatrix F, TMatrix A_ref, TMatrix F_ref, TMatrix IM);

/*
void NormalizeWaldMethod(TMatrix A, TMatrix A_hat, TMatrix S);
void NormalizeVariableWaldMethod(TMatrix A, TMatrix A_hat);
TMatrix InformationMatrix(TMatrix A);
TMatrix InformationMatrixData(TMatrix A, TMatrix Data);
void NormalizeWald_old(TMatrix A, TWaldNormalization *parms);
TWaldNormalization* CreateWaldNormalizationParameters(TMatrix A_hat);

void Destruct_TWaldNormalization(TWaldNormalization *params);
TWaldNormalization* CreateWaldNormalizationParameters_2ndDerivative(TMatrix A, TMatrix F, TMatrix Data, TMatrix Exg, int p);
TWaldNormalization* CreateWaldNormalizationParameters_1stDerivative(TMatrix A, TMatrix F, TMatrix Data, TMatrix Exg, int p);
*/

#endif
