% This MATLAB program plots contours for supply example
% first load in data
load ydata.txt -ascii
[rows,cols] = size(ydata)

% convert to resids to concentrate likelihood function
y0 = ydata(4:rows,:);
y1 = ydata(3:rows-1,:);
y2 = ydata(2:rows-2,:);
xmat = [y1 y2];
bhat = inv(xmat'*xmat)*xmat'*y0;
uhat = y0 - xmat*bhat;
x2mat = [y1(:,3) y2(:,3)];      % x2mat just has the weather
b2hat = inv(x2mat'*x2mat)*x2mat'*y0(:,3);
uhat(:,3) = y0(:,3) - x2mat*b2hat;  % so likelihood is concentrated with
                                    % restrictions on B1 and B2
ydata = uhat;

A = [ 1.0000000        2.0000000       0.00000000 
       1.0000000      -0.50000000       0.50000000 
      0.00000000       0.00000000        1.0000000 ]
likely(ydata,A,ones(3,1))

subplot('Position',[0.1 0.72 0.32 0.19])
[alpha1,alpha2,likes,thet] = twobytwo(1,ones(3,1),ydata);
contourmax;
title('h=1')

subplot('Position',[0.52 0.72 0.32 0.19])
[alpha1,alpha2,likes,thet] = twobytwo(0.5,ones(3,1),ydata);
contourmax;
title('h=0.5')

subplot('Position',[0.1 0.40 0.32 0.19])
[alpha1,alpha2,likes,thet] = twobytwo(0.11,ones(3,1),ydata);
contourmax;
title('h=0.1')

subplot('Position',[0.52 0.40 0.32 0.19])
[alpha1,alpha2,likes,thet] = twobytwo(0,ones(3,1),ydata);
contourmax;
title('h=0')

subplot('Position',[0.1 0.08 0.32 0.19])
[alpha1,alpha2,likes,thet] = twobytwo(-0.5,ones(3,1),ydata);
contourmax;
title('h=-0.5')

subplot('Position',[0.52 0.08 0.32 0.19])
[alpha1,alpha2,likes,thet] = twobytwo(-1,ones(3,1),ydata);
contourmax;
title('h=-1')
